
/*
 * $Id: Oid.cc,v 1.1.2.1 1999/10/16 06:02:47 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include <iostream.h>
#include <iomanip.h>

#include "Oid.h"


void OidRec::reset() {
	wid.clear();
	sidx = tid = oid = -1;
	repeat = cachable = hit = false;
}

ostream &OidRec::printOid(ostream &os) const {
	const ios::fmtflags flags = os.flags();
	const char fill = os.fill('0');
	os << hex << setfill('0') << setw(8) << oid;
	os.fill(fill);
	os.flags(flags);
	return os;
}

ostream &OidRec::printUriPath(ostream &os) const {
	os << 'w' << wid << '/';
	if (tid)
		os << 't' << tid << '/';
	printOid(os << '_');
	return os;
}

ostream &OidRec::printFlags(ostream &os) const {
	if (repeat)
		os << "rpt,";
	if (cachable)
		os << "chb,";
	if (hit)
		os << "hit";
	return os;
}

ostream &OidRec::print(ostream &os) const {
	os << "srv: " << sidx;
	printUriPath(os << " path: ");
	printFlags(os << " flags: ");
	return os;
}
