
/*
 * $Id: BcastChannel.h,v 1.2 1999/09/07 17:46:47 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_BROADCAST_CHANNEL_H
#define PG_BROADCAST_CHANNEL_H

#include "Array.h"
#include "String.h"
#include "BcastRcver.h"

// event distribution channel

class BcastChannel: protected SchArray<BcastRcver*> {
	public:
		BcastChannel(const String &anEvName);

		int startBcast() const { if (Debug) showEvent(); return theCount; }
		BcastRcver* rcver(int idx) { return item(idx); }

		void subscribe(BcastRcver* rcver);
		void unsubscribe(BcastRcver* rcver);

	protected:
		void showEvent() const;

	public:
		static bool Debug; // debug flag is shared by all Channels

	protected:
		String theName;
};

template<class EvType>
inline
void Broadcast(BcastChannel *ch, EvType ev) {
	int i = ch->startBcast();
	while (--i >= 0)
		ch->rcver(i)->noteEvent(ch, ev);
}

#endif
