
/*
 * $Id: CntSzStat.h,v 1.3 1999/09/07 17:46:50 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_COUNT_AND_SIZE_STATS_H
#define PG_COUNT_AND_SIZE_STATS_H

#include "BigSize.h"

class OLog;
class ILog;

// handy for counting objects with size component
class CntSzStat {
	public:
		CntSzStat();

		void reset();
		OLog &store(OLog &log) const;
		ILog &load(ILog &);

		void record(Size sz) { ++theCnt; if (sz > 0) theSz += sz; }
		int count() const { return theCnt; }
		const BigSize &size() const { return theSz; }

		CntSzStat &operator +=(const CntSzStat &s);

	protected:
		int theCnt;
		BigSize theSz;
};

inline OLog &operator <<(OLog &ol, const CntSzStat &s) { return s.store(ol); }
inline ILog &operator >>(ILog &il, CntSzStat &s) { return s.load(il); }

#endif
