
/*
 * $Id: ConnIdx.h,v 1.2 1999/09/07 17:46:51 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CONNECTION_INDEX_H
#define PG_CONNECTION_INDEX_H

#include "Array.h"


// fd -> connection map
// we can make this map generic (fd->something) map when needed

class Connection;

class ConnIdx: protected Array<Connection*> {
	public:
		ConnIdx(int aCapacity = 0);

		void fdLimit(int limit);

		void add(Connection *conn);
		void del(Connection *conn);

		// asserts that conn belongs to the index
		void check(const Connection *conn);

		Connection *operator [](int fd) const { return item(fd); }

	protected:
		// checks that conn's place is occupied by val and returns the "place"
		Connection *&safeItem(const Connection *conn, const Connection *val);
};

#endif
