
/*
 * $Id: ContentCfg.h,v 1.4 1999/09/26 21:51:23 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CONTENT_CONFIGURATION_H
#define PG_CONTENT_CONFIGURATION_H

#include "String.h"
#include "ObjLifeCycle.h"

class RndDistr;
class ContentSym;
class EmbedContMdl;

class ContentCfg {
	public:
		ContentCfg(int anId);

		void configure(const ContentSym *cfg);

		int id() const { return theId; }

		double compLocalContrib(ContentCfg *cc) const;
		void noteGlobalContrib(ContentCfg *cc, double cc_prob, double contrib);

	public:
		String theMimeType;
		RndDistr *theSize;
		ObjLifeCycle theObjLifeCycle;
		double theChbRatio;

		EmbedContMdl *theEmbedCont;

	protected:
		int theId;
};

#endif
