
/*
 * $Id: ContentMgr.h,v 1.1 1999/09/26 21:51:24 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CONTENT_MANAGER_H
#define PG_CONTENT_MANAGER_H

#include "Array.h"

class ContentCfg;
class ContentSym;

// aggregates information about content descriptions
// prevents creation of large number of identical descriptions

class ContentMgr {
	public:
		ContentMgr();
		~ContentMgr();

		ContentCfg *get(const ContentSym *cs);
		ContentCfg *get(int id);

		ContentCfg *operator [](int id) { return get(id); }
		
	protected:
		Array<ContentCfg*> theCfgs;
		Array<ContentSym*> theSyms; // kept to search for new symbols
};

extern ContentMgr TheContentMgr;

#endif
