
/*
 * $Id: ExpPortMgr.h,v 1.5 1999/09/26 23:36:20 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_EXPLICIT_PORT_MGR_H
#define PG_EXPLICIT_PORT_MGR_H

#include "Ring.h"
#include "PortMgr.h"

// fifo pool of ports, explicit mapping with bind
class ExpPortMgr: public PortMgr {
	public:
		ExpPortMgr(const NetAddr &anAddr, int aPortMin, int aPortMax);

		void configure(int aPortMin, int aPortMax);

	protected:

		virtual int allocPort(Socket &s);
		virtual void freePort(int port, bool good);

		int findPort(Ring<int> &ports, Socket &s);
		bool bindToPort(Socket &s, int port) const;
		bool usedPort(int port) const;

	protected:
};

#endif
