
/*
 * $Id: ConsoleSym.cc,v 1.3 1999/09/07 17:47:36 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "String.h"
#include "PglIntSym.h"
#include "PglRec.h"
#include "PglStringSym.h"
#include "ConsoleSym.h"


ConsoleSym::ConsoleSym(const String &aType): RecSym(aType, new PglRec) {

	// add fields

	theRec->bAdd("string", "fname", 0);
	theRec->bAdd("int", "verb_lvl", 0);
}

ConsoleSym::ConsoleSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool ConsoleSym::isA(const String &type) const {
	return RecSym::isA(type) ||	type == "Console";
}

SynSym *ConsoleSym::clone(const String &type) const {
	if (isA(type))
		return new ConsoleSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}
