
/*
 * $Id: AgentSym.h,v 1.4.6.1 1999/09/30 19:38:46 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_AGENT_SYMBOL_H
#define PG_AGENT_SYMBOL_H

#include "PglRecSym.h"
#include "NetAddr.h"

class RndDistr;
class SocketSym;
class NetAddrSym;

// base class for robot and server symbols
class AgentSym: public RecSym {
	public:
		AgentSym(const String &aType);
		AgentSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		int hostCount() const;
		NetAddrSym *host(int idx) const;

		String kind() const;
		bool hosts(Array<NetAddrSym*> &addrs) const;
		SocketSym *socket() const;
		RndDistr *xactThink() const;
		RndDistr *pconnUseLmt() const;
};

#endif
