
/*
 * $Id: PglListSym.h,v 1.4 1999/09/07 17:48:04 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_LIST_SYMBOL_H
#define PGL_LIST_SYMBOL_H

#include "Array.h"
#include "pglSyms.h"

// list of symbols of a any types
class ListSym: protected Array<SynSym*>, public ExpressionSym {
	public:
		ListSym(const String &aType = "List");
		virtual ~ListSym();

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		int count() const { return Array<SynSym*>::count(); }
		const SynSym *operator [](int idx) const { return this->item(idx); }

		void add(const SynSym &s);

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		bool absorb(const ListSym &arr);
		void doAdd(SynSym *sclone, const SynSym &s);

		virtual void addFailure(const SynSym &s);
		virtual bool cadd(const SynSym &s);
};

#endif
