
/*
 * $Id: PglNetAddrRange.h,v 1.1.2.2 1999/10/01 19:04:44 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_NET_ADDRESS_RANGE_H
#define PGL_NET_ADDRESS_RANGE_H

#include "Array.h"

class String;
class ArraySym;

class PglNetAddrRange {
	protected:
		struct Block { 
			int min, max;
			int pos;

			Block();
			bool valid() const;
		};

	public:
		PglNetAddrRange();
		~PglNetAddrRange();

		// use subnet specs or guess an approprite netmask for the range
		void netmask(struct in_addr &pin) const;

		ArraySym *toSyms();
		void toAddrs(Array<NetAddr*> &addrs);
		bool parse(const String &val);
		
	protected:
		void startIter();
		bool nextIter();
		bool nextIter(int level);
		void currentIterAddr(String &str);
		
		bool parseBlock(const String &val);
		
	protected:
		Array<Block> theBlocks; // address octet specs
		int theSubnet;          // optiona subnet specs
		int thePort;            // one for all, if any
		int theRangeCnt;        // number of blocks specified using a range
		int theSpillCnt;        // number of blocks spanning class-X boundaries

	private:
		Array<String*> theStrs; // temporary storage for parsing
	
};

#endif
