
/*
 * $Id: Clock.h,v 1.3 1999/09/17 23:55:01 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef X_CLOCK_H
#define X_CLOCK_H

#include "Time.h"

// an object that can show current time and responds to time changes
// clocks are syncronized via Clock::Update() call

class Clock {
	public:
		static Time Update(bool advanceAll = true);
		static Time TheStartTime;

	public:
		Clock();
		virtual ~Clock();

		Time time() const { return theCurTime; }
		operator Time() const { return theCurTime; }
		Time runTime() const { return theCurTime - TheStartTime; }
	
		Time now() { update(Time::Now()); return theCurTime; }
		virtual void update(Time aCurTime) { theCurTime = aCurTime; }

	protected:
		Time theCurTime;
};

// "Wall clock" or "official clock" (it is always advanced by UpdateClocks())
extern Clock TheClock;


// internal object to initialize Clock library, ignore
class ClockLibCounter {
	public:
		ClockLibCounter();
		~ClockLibCounter();
	protected:
		static int theUseCount;
};
static ClockLibCounter TheClockLibCounter;

#endif
