
/*
 * $Id: fixPoll.h,v 1.4 1999/09/07 17:48:47 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef XSTD_FIX_POLL_H
#define XSTD_FIX_POLL_H

#ifdef HAVE_POLL
#include <poll.h>

/* Linux does not define "NORM" */
#ifndef POLLRDNORM
#define POLLRDNORM POLLIN
#endif
#ifndef POLLWRNORM
#define POLLWRNORM POLLOUT
#endif

inline
int xpoll(pollfd *fds, unsigned int nfds, int timeout) {
	return ::poll(fds, nfds, timeout);
}

#else

#define POLLRDNORM 1
#define POLLWRNORM 2
#define POLLERR 4
#define POLLHUP 8
#define POLLNVAL 16

struct pollfd { int fd;  short events; short revents; };
extern int xpoll(pollfd *fds, unsigned int nfds, int timeout);

#endif


#endif
